From 5a6c7b534d33680606570ffe78b025c145fe6655 Mon Sep 17 00:00:00 2001
From: Adrian Taylor <adetaylor@chromium.org>
Date: Aug 25 2020 20:08:38 +0000
Subject: [PATCH 686/2232] Add option to omit type definitions.


A higher-level code generator may provide instructions to cxx
based on existing defined C++ types. In such an instance, we don't want
cxx to redefine those types, because this will cause violations of the
one-definition-rule. This commit provides an option to prevent such
redefinition.

As this is only likely to be used from higher-level code generators,
we do not expose this option via 'cmd' or 'build' front-ends for
code generation.

---

diff --git a/gen/src/mod.rs b/gen/src/mod.rs
index f2e5c9b..1c84a23 100644
--- a/gen/src/mod.rs
+++ b/gen/src/mod.rs
@@ -34,6 +34,8 @@ pub struct Opt {
     /// Whether to set __attribute__((visibility("default")))
     /// or similar annotations on function implementations.
     pub cxx_impl_annotations: Option<String>,
+    /// Whether to omit definitions of types.
+    pub omit_type_definitions: bool,
 }
 
 /// Results of code generation.
diff --git a/gen/src/write.rs b/gen/src/write.rs
index 51c4b02..b184b52 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -60,7 +60,7 @@ pub(super) fn gen(
 
     for api in apis {
         match api {
-            Api::Struct(strct) => {
+            Api::Struct(strct) if !opt.omit_type_definitions => {
                 out.next_section();
                 write_struct(out, strct);
             }
@@ -68,7 +68,7 @@ pub(super) fn gen(
                 out.next_section();
                 if types.cxx.contains(&enm.ident) {
                     check_enum(out, enm);
-                } else {
+                } else if !opt.omit_type_definitions {
                     write_enum(out, enm);
                 }
             }

